//
//  TPPUICollectionViewCell.m
//  PhotoPhun
//
//  Created by Gabe Nadel on 6/13/16.
//  Copyright © 2016 Gabe Nadel. All rights reserved.
//

#import "TPPUICollectionViewCell.h"

@implementation TPPUICollectionViewCell

-(void)setPhotoData:(NSDictionary *)photoData{
    _photoData = photoData;
    
    NSString *size = @"100x100";
    
    NSString *urlString = [[NSString alloc]initWithFormat:@"%@%@%@", [photoData valueForKeyPath:@"response.venue.bestPhoto.prefix"], size, [photoData valueForKeyPath:@"response.venue.bestPhoto.suffix"]];
    
    [self downloadPhotoWithURL:urlString];
    
}

-(void)downloadPhotoWithURL:(NSString*)urlString{
    
    NSString *key = urlString;
    UIImage *cachedPhoto = [[SAMCache sharedCache]imageForKey:key];
    
    if(cachedPhoto){
        self.photoView.image = cachedPhoto;
        return;
    }
    
    NSURL *url = [[NSURL alloc]initWithString:urlString];
    NSURLSession *session = [NSURLSession sharedSession];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    NSURLSessionDownloadTask *task = [session downloadTaskWithRequest:request completionHandler:^(NSURL * _Nullable location, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        NSData *data = [[NSData alloc]initWithContentsOfURL:location];
        UIImage *image = [[UIImage alloc]initWithData:data];
        [[SAMCache sharedCache] setImage:image forKey:key];
        
        dispatch_async(dispatch_get_main_queue(), ^{
            self.photoView.image = image;
        });
    }];
    
    [task resume];
}

@end
